#!/bin/sh
#run this after 2modules.sh
#141207 copy 4convert-kernel-source-sfs-to-pet
#150326 copy 1recompile.sh
#160413 fix 'build' and 'source' symlinks.
#170305 test if 4convert-kernel-source-sfs-to-pet exists.

. /etc/DISTRO_SPECS
KERNELVERSION="`uname -r`"
[ ! -d linux-${KERNELVERSION} ] && exit

DASHOUT="`find /usr/src -maxdepth 1 -type d -name "out-k${KERNELVERSION}-*"`"
if [ "$DASHOUT" ];then
 POSTVER="-`echo -n "$DASHOUT" | rev | cut -f 1 -d '-' | rev`" #ex: -43
else
 POSTVER=""
fi

#clean...
cd linux-${KERNELVERSION}
make clean
make prepare
sync
cd ..

#finish off...
cp -f 1kernel.sh out-k${KERNELVERSION}${POSTVER}/
cp -f 1recompile.sh out-k${KERNELVERSION}${POSTVER}/ #150326
cp -f 2modules.sh out-k${KERNELVERSION}${POSTVER}/
cp -f 3package.sh out-k${KERNELVERSION}${POSTVER}/
[ -f ./4convert-kernel-source-sfs-to-pet ] && cp -f 4convert-kernel-source-sfs-to-pet out-k${KERNELVERSION}${POSTVER}/ #141207 170305
sync
echo "Creating kernel source sfs..."
rm -rf kernel_src-${KERNELVERSION}${POSTVER}-patched 2> /dev/null
mkdir kernel_src-${KERNELVERSION}${POSTVER}-patched
mkdir -p kernel_src-${KERNELVERSION}${POSTVER}-patched/usr/src
mkdir -p kernel_src-${KERNELVERSION}${POSTVER}-patched/lib/modules/${KERNELVERSION}
cp -a -f linux-${KERNELVERSION} kernel_src-${KERNELVERSION}${POSTVER}-patched/usr/src/
ln -s linux-${KERNELVERSION} kernel_src-${KERNELVERSION}${POSTVER}-patched/usr/src/linux

#160413 fix 'build' and 'source' symlinks, when /usr/src is a symlink to another partition...
#cp -a -f /lib/modules/${KERNELVERSION}/build kernel_src-${KERNELVERSION}${POSTVER}-patched/lib/modules/${KERNELVERSION}/
#cp -a -f /lib/modules/${KERNELVERSION}/source kernel_src-${KERNELVERSION}${POSTVER}-patched/lib/modules/${KERNELVERSION}/
ln -s /usr/src/linux-${KERNELVERSION} kernel_src-${KERNELVERSION}${POSTVER}-patched/lib/modules/${KERNELVERSION}/build
ln -s /usr/src/linux-${KERNELVERSION} kernel_src-${KERNELVERSION}${POSTVER}-patched/lib/modules/${KERNELVERSION}/source

sync
mksquashfs4 kernel_src-${KERNELVERSION}${POSTVER}-patched out-k${KERNELVERSION}${POSTVER}/kernel_src-${KERNELVERSION}${POSTVER}-patched.sfs
sync
chmod 644 out-k${KERNELVERSION}${POSTVER}/kernel_src-${KERNELVERSION}${POSTVER}-patched.sfs

#create pet
echo "Finished, however you can do one more thing..."
echo -n "Press ENTER to create PET, any other char to quit: "
read shalliquit
[ "$shalliquit" != "" ] && exit
echo
echo "The PET package will be named something like"
echo "'linux_kernel-${KERNELVERSION}${POSTVER}-pae-i686-w5.pet'"
echo -n "Type a string for the 'pae-i686-w5' part: "
read PETPOSTSTR
rm -rf linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}
mkdir linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}
mkdir linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/boot
mkdir -p linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/etc/modules
mkdir -p linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/lib/modules

cp -f out-k${KERNELVERSION}${POSTVER}/System.map linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/boot/
cp -f out-k${KERNELVERSION}${POSTVER}/vmlinuz linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/boot/
cp -f out-k${KERNELVERSION}${POSTVER}/DOTconfig-${KERNELVERSION}${POSTVER} linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/etc/modules/
cp -f out-k${KERNELVERSION}${POSTVER}/modules.builtin linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/etc/modules/ 2>/dev/null #<=2.6.32 does not have this.
cp -f out-k${KERNELVERSION}${POSTVER}/modules.order linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/etc/modules/

cp -f out-k${KERNELVERSION}${POSTVER}/firmware.tar.gz linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/lib/
cd linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/lib
tar -zxf firmware.tar.gz
sync
rm -f firmware.tar.gz
cd ../../

cp -f out-k${KERNELVERSION}${POSTVER}/${KERNELVERSION}.tar.gz linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/lib/modules/
cd linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/lib/modules
tar -zxf ${KERNELVERSION}.tar.gz
sync
rm -f ${KERNELVERSION}.tar.gz
rm -f ${KERNELVERSION}/build
rm -f ${KERNELVERSION}/source
rm -f ${KERNELVERSION}/modules.*
cd ../../
DB_size="`du -k -s | cut -f 1`"
cd ../

#mkdir linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/lib/modules/${KERNELVERSION}/misc
#cp -f out-k${KERNELVERSION}${POSTVER}/${NDISWRAPPERDIR}-i486/lib/modules/${KERNELVERSION}/misc/ndiswrapper.ko linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/lib/modules/${KERNELVERSION}/misc/

#ex: linux_kernel-2.6.39-3-pae-i686-1-w5|linux_kernel|2.6.39-3-pae-i686-1-w5||BuildingBlock|65772K||linux_kernel-2.6.39-3-pae-i686-1-w5.pet||Linux kernel 2.6.39-3 compiled in Wary with gcc 4.3.4, smp-enabled, has usb-storage patch, pae-enabled, i686 Pentium-Pro and later CPU, does not support isa bus|puppy|wary5||
echo "linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}|linux_kernel|${KERNELVERSION}${POSTVER}-${PETPOSTSTR}||BuildingBlock|${DB_size}K||linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.pet||Linux kernel ${KERNELVERSION}${POSTVER} compiled in ${DISTRO_NAME} version ${DISTRO_VERSION}|${DISTRO_BINARY_COMPAT}|${DISTRO_COMPAT_VERSION}||" > linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}/pet.specs
sync

dir2tgz linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}
sync
tgz2pet linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.tar.gz
sync
mv -f linux_kernel-${KERNELVERSION}${POSTVER}-${PETPOSTSTR}.pet out-k${KERNELVERSION}${POSTVER}/
sync

echo "Finished"
###END###

